#include "p79.h"

static char	*Cuserid ARGS((char *s));

/* Return the user login name */

void
FORTRAN(p79log,P79LOG)(username, FLENARG(username))
FCHAR		username;
int		FLENARG(username);
{
    int		n;
    char	*p;

    p = (char*)getlogin();

    if (p == (char*)NULL)
	p = Cuserid((char*)NULL);
    if (p)
    {
	n = strlen(p);
	(void)memcpy(&CH(username,0),p,n);
	(void)memset(&CH(username,n),' ',FLEN(username) - n);
    }
    else
	(void)memset(&CH(username,0),' ',FLEN(username));
}

/* BSD 4.x, Sys V, and IBM AIX all have cuserid(), but NeXT with MACH is
lacking it.  The version implemented here should work for all these systems. */

#include <pwd.h>

#if !defined(_IBMR2) && !defined(__sgi)
struct passwd		*getpwuid ARGS((int uid));
#endif /* !defined(_IBMR2) && !defined(__sgi) */

#define MAXUSERNAME	39

static char*
Cuserid(s)
char  *s;
{
    static char		username[MAXUSERNAME+1];

    username[0] = '\0';			/* default value is empty string */

    {
	char			*p;
	struct passwd		*pw;

	p = (char*)getlogin();
	if (p == (char*)NULL)
	{
	    pw = getpwuid((int)getuid());
	    if (pw != (struct passwd *)NULL)
		p = pw->pw_name;
	}
	if (p != (char*)NULL)
	    (void)strncpy(username,p,MAXUSERNAME);

    }

    if (s != (char*)NULL)
	(void)strcpy(s,username);

    return ((char*)username);
}
