      SUBROUTINE  SAVLBL
C     (SAVLBL)
C     PROCEDURE (Save SFTRAN Label, if any)
C
C     Examines current statement  for an SFTRAN  label and  saves
C     it, if any, in array 'LABELS'.
C     (13-FEB-85)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       CHGET3,      F4MVC,       SCANER,      SFTERR
C     EXTERNAL REFS       SQUEEZ
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             CHGET3
      LOGICAL             SCANER
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                BYTE2,       I,           LJUNK,       NCHARS
C
      INTEGER             BUF(40),     BYTE2,       DUMMY,       I
      INTEGER             NCHARS
      LOGICAL             LJUNK
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM01  /
C
      INTEGER             BYTE,        CC,          CCLABL
      INTEGER             CCMORE,      IN,          INDENT
      INTEGER             LLABL,       MLABL
      INTEGER             NHELD,       OUT
      INTEGER             UNDENT
      LOGICAL             EOF,         FIRST,       LABEL,       LAST
      LOGICAL             MORE
C
      COMMON / COM01  /   BYTE,        CC,          CCLABL
      COMMON / COM01  /   CCMORE,      EOF,         FIRST,       IN
      COMMON / COM01  /   INDENT,      LABEL,       LAST
      COMMON / COM01  /   LLABL,       MLABL,       MORE
      COMMON / COM01  /   NHELD
      COMMON / COM01  /   OUT,         UNDENT
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM02  /
C
      INTEGER             CCFLGS,      CCLIST,      CCNAME,      CCRW
      INTEGER             DEFNO,       INDEXS,      LFLGS,       LLIST
      INTEGER             LLOGS,       MAXLEV,      NEXT
C
      COMMON / COM02  /   CCFLGS(2),   CCLIST,      CCNAME,      CCRW
      COMMON / COM02  /   DEFNO,       INDEXS(38,39)
      COMMON / COM02  /   LFLGS(2),    LLIST,       LLOGS(2)
      COMMON / COM02  /   MAXLEV,      NEXT
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM05  /
C
      INTEGER             BLANKS,      LEFT,        LEVEL
      INTEGER             RIGHT,       S0,          S1,          STRCTS
      COMMON / COM05  /   BLANKS(92),  LEFT,        LEVEL
      COMMON / COM05  /   RIGHT,       S0,          S1
      COMMON / COM05  /   STRCTS(39)
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM12  /
C
      INTEGER             ALIGN,       LNUPCH,      MAXOUT,      STETCH
      LOGICAL             COMMNT,      DRECTV,      EXEMPT,      LINEUP
      LOGICAL             NONDNT,      STET
C
      COMMON / COM12  /   ALIGN(120),  COMMNT,      DRECTV,      EXEMPT
      COMMON / COM12  /   LINEUP,      LNUPCH(1),   MAXOUT,      NONDNT
      COMMON / COM12  /   STET,        STETCH(1)
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM14  /
C
      INTEGER             WDSIZE
C
      COMMON / COM14  /   WDSIZE
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM24  /
C
      INTEGER             FIND,        LOCATE,      SCAN
C
      COMMON / COM24  /   FIND,        LOCATE,      SCAN
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM29  /
C
      INTEGER             LABELS,      LBLPTR,      MAXLAB
C
      COMMON / COM29  /   LABELS(199), LBLPTR(39,2),MAXLAB
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM31  /
C
      INTEGER             NS,          NSMAX,       STMT
C
      COMMON / COM31  /   NS,          NSMAX,       STMT(1326)
C
C
C     Check for any non-blanks from column 1 onward
C
      LJUNK=SCANER(SCAN,DUMMY,1)
C
C     SFTRAN label is present if (1) a non-blank starts in cols 2-5,
C     and (2) is a letter.
C
      IF (.NOT.(MORE .AND. CCMORE.LE.5 .AND. CCMORE.GE.2)) GO TO 20001
      BYTE = CHGET3(STMT,CCMORE)
      LABEL=.TRUE.
      I =1
      GO TO 20006
20005 I =I +1
20006 IF ((26-I ).LT.0) GO TO 20007
      BYTE2 = CHGET3(26HABCDEFGHIJKLMNOPQRSTUVWXYZ,I)
      IF (BYTE .EQ. BYTE2) GO TO 20004
      GO TO 20005
20007 LABEL=.FALSE.
      IF (SCANER(LOCATE,1H:,1)) CALL SFTERR (1,                       54
     XH(Label ignored. SFTRAN labels must start with letter.))
20004 GO TO 20002
20001 LABEL=.FALSE.
20002 CONTINUE
C
C     If label is present,  record its starting position,  search
C     for its delimiter, and determine its length.
C
20003 IF (.NOT.(LABEL)) GO TO 20009
      CCLABL=CCMORE
      IF (.NOT.(SCANER(LOCATE,1H:,1))) GO TO 20012
      IF (.NOT.((CC-CCLABL+1) .LE. MLABL)) GO TO 20015
      LLABL = CC-CCLABL+1
      GO TO 20016
20015 LLABL = MLABL
      CALL SFTERR(1,
     X46H(Label exceeds 38 characters including blanks))
      CALL F4MVC(BLANKS,1,STMT,CCLABL+MLABL,CC-MLABL-
     XCCLABL-1)
20016 GO TO 20013
20012 LLABL = MLABL
      CALL SFTERR(1,38H(No label delimiter. Max length used.))
20013 GO TO 20010
20009 LLABL = 0
C
C     Set pointers and save label, if any, if room.   LBLPTR(K,1)
C     points to  starting  byte of  LABEL  at level  K  in  array
C     'LABELS'.  LBLPTR(K,2) gives its length in bytes.
C
20010 IF (.NOT.((LEVEL+1) .GT. MAXLEV)) GO TO 20018
      CALL SFTERR(2,28H(Too many levels of nesting))
      GO TO 20019
20018 IF (.NOT.(LABEL)) GO TO 20021
      ASSIGN 20024 TO NPR001
      GO TO 30001
20024 GO TO 20022
20021 NCHARS = 0
20022 IF (.NOT.((LEVEL + 1) .LT. MAXLEV)) GO TO 20025
      LBLPTR(LEVEL+1,2) = NCHARS
      LBLPTR(LEVEL+2,1) = LBLPTR(LEVEL+1,1) + NCHARS
20025 IF (.NOT.((LBLPTR(LEVEL+1,1) + NCHARS) .GT. (WDSIZE*MAXLAB))) GO T
     XO 20028
      CALL SFTERR(2,32H(Structure LABEL table overflow))
      GO TO 20029
20028 IF (.NOT.(NCHARS .GT. 0)) GO TO 10001
      CALL F4MVC(BUF,1,LABELS,LBLPTR(LEVEL+1,1),NCHARS)
10001 CONTINUE
20029 CONTINUE
C
C     Point to first byte of code or comment text
C
20019 IF (.NOT.(LABEL)) GO TO 20031
      LJUNK=SCANER(SCAN,DUMMY,CC+1)
      GO TO 20032
20031 IF (.NOT.(COMMNT)) GO TO 10002
      LJUNK=SCANER(SCAN,DUMMY,2)
      GO TO 20032
10002 LJUNK=SCANER(SCAN,DUMMY,7)
C
20032 RETURN
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Remove Blanks from SFTRAN Label)
30001 CALL SQUEEZ(CCLABL,CC,BUF,NCHARS)
      GO TO 20024
C
      END
